/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_STUB_DEFAULT_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_STUB_DEFAULT_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesStubDefault.hpp>

#include <CommonAPI/Export.hpp>

#include <v1/commonapi/telux/cv2x/Cv2xRadioStub.hpp>
#include <cassert>
#include <sstream>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

/**
 * Provides a default implementation for Cv2xRadioStubRemoteEvent and
 * Cv2xRadioStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT Cv2xRadioStubDefault
    : public virtual Cv2xRadioStub,
      public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubDefault {
public:
    COMMONAPI_EXPORT Cv2xRadioStubDefault()
        : remoteEventHandler_(this),
          interfaceVersion_(Cv2xRadio::getInterfaceVersion()) {
    }

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return interfaceVersion_;
    }

    COMMONAPI_EXPORT Cv2xRadioStubRemoteEvent* initStubAdapter(const std::shared_ptr< Cv2xRadioStubAdapter> &_adapter) {
        Cv2xRadioTypesStubDefault::initStubAdapter(_adapter);
        CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_ = _adapter;
        return &remoteEventHandler_;
    }

    COMMONAPI_EXPORT virtual void createRxSubscription(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint16_t _port, std::vector< uint32_t > _idList, createRxSubscriptionReply_t _reply) {
        (void)_client;
        (void)_ipType;
        (void)_port;
        (void)_idList;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        uint32_t subscriptionId = 0ul;
        _reply(error, subscriptionId);
    }
    COMMONAPI_EXPORT virtual void getServiceStatus(const std::shared_ptr<CommonAPI::ClientId> _client, getServiceStatusReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::common::CommonDefines::ServiceStatus status = ::v1::commonapi::telux::common::CommonDefines::ServiceStatus::SERVICE_UNAVAILABLE;
        if (!status.validate()) {
            return;
        }
        _reply(error, status);
    }
    COMMONAPI_EXPORT virtual void enableRxMetaDataReport(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, bool _enable, std::vector< uint32_t > _idList, enableRxMetaDataReportReply_t _reply) {
        (void)_client;
        (void)_ipType;
        (void)_enable;
        (void)_idList;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        _reply(error);
    }
    COMMONAPI_EXPORT virtual void createTxSpsFlow(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, uint16_t _spsSrcPort, bool _eventSrcPortValid, uint16_t _eventSrcPort, createTxSpsFlowReply_t _reply) {
        (void)_client;
        (void)_ipType;
        (void)_serviceId;
        (void)_spsInfo;
        (void)_spsSrcPort;
        (void)_eventSrcPortValid;
        (void)_eventSrcPort;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        uint32_t txSpsFlowId = 0ul;
        uint32_t txEventFlowId = 0ul;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode spsError = ::v1::commonapi::telux::common::CommonDefines::ErrorCode::SUCCESS;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode eventError = ::v1::commonapi::telux::common::CommonDefines::ErrorCode::SUCCESS;
        if (!spsError.validate()) {
            return;
        }
        if (!eventError.validate()) {
            return;
        }
        _reply(error, txSpsFlowId, txEventFlowId, spsError, eventError);
    }
    COMMONAPI_EXPORT virtual void createTxEventFlow(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipTyp, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _flowInfo, uint16_t _eventSrcPort, createTxEventFlowReply_t _reply) {
        (void)_client;
        (void)_ipTyp;
        (void)_serviceId;
        (void)_flowInfo;
        (void)_eventSrcPort;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        uint32_t txEventFlowId = 0ul;
        _reply(error, txEventFlowId);
    }
    COMMONAPI_EXPORT virtual void closeRxSubscription(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _subscriptionId, closeRxSubscriptionReply_t _reply) {
        (void)_client;
        (void)_subscriptionId;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        _reply(error);
    }
    COMMONAPI_EXPORT virtual void closeTxFlow(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, closeTxFlowReply_t _reply) {
        (void)_client;
        (void)_txFlowId;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        _reply(error);
    }
    COMMONAPI_EXPORT virtual void changeSpsFlowInfo(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, changeSpsFlowInfoReply_t _reply) {
        (void)_client;
        (void)_txFlowId;
        (void)_spsInfo;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        _reply(error);
    }
    COMMONAPI_EXPORT virtual void requestSpsFlowInfo(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, requestSpsFlowInfoReply_t _reply) {
        (void)_client;
        (void)_txFlowId;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo spsInfo = {};
        _reply(error, spsInfo);
    }
    COMMONAPI_EXPORT virtual void changeEventFlowInfo(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _eventInfo, changeEventFlowInfoReply_t _reply) {
        (void)_client;
        (void)_txFlowId;
        (void)_eventInfo;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        _reply(error);
    }
    COMMONAPI_EXPORT virtual void requestCapability(const std::shared_ptr<CommonAPI::ClientId> _client, requestCapabilityReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities capabilities = {};
        _reply(error, capabilities);
    }
    COMMONAPI_EXPORT virtual void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) {
        Cv2xRadioStub::fireCurrentCv2xStatusEvent(_status);
    }
    COMMONAPI_EXPORT virtual void fireCurrentCv2xStatusExEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx) {
        Cv2xRadioStub::fireCurrentCv2xStatusExEvent(_statusEx);
    }
    COMMONAPI_EXPORT virtual void fireCurrentL2AddrEvent(const uint32_t &_newL2Addr) {
        Cv2xRadioStub::fireCurrentL2AddrEvent(_newL2Addr);
    }
    COMMONAPI_EXPORT virtual void fireCurrentSpsOffsetEvent(const int32_t &_spsId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails &_details) {
        Cv2xRadioStub::fireCurrentSpsOffsetEvent(_spsId, _details);
    }
    COMMONAPI_EXPORT virtual void fireCurrentCapabilitiesEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities) {
        Cv2xRadioStub::fireCurrentCapabilitiesEvent(_capabilities);
    }
    COMMONAPI_EXPORT virtual void fireMacAddrCloneEvent(const bool &_detected) {
        Cv2xRadioStub::fireMacAddrCloneEvent(_detected);
    }


protected:
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual Cv2xRadioStubRemoteEvent, public virtual Cv2xRadioTypesStubDefault::RemoteEventHandler {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(Cv2xRadioStubDefault *_defaultStub)
            : ::v1::commonapi::telux::common::CommonDefinesStubDefault::RemoteEventHandler(_defaultStub), ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubDefault::RemoteEventHandler(_defaultStub),
              defaultStub_(_defaultStub) {
        }


    private:
        Cv2xRadioStubDefault *defaultStub_;
    };
protected:
    Cv2xRadioStubDefault::RemoteEventHandler remoteEventHandler_;

private:


    CommonAPI::Version interfaceVersion_;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_STUB_DEFAULT
